// CD 02/2010
// horloge temps reel
// quartz 4MHz

#include <p18f4620.h>
#include <stdio.h>  // pour printf

#define S2 ? 

#define DATA PORTD		// donnee 7 seg

#define KAFF1 PORTCbits.RC0		
#define KAFF2 ?
#define KAFF3 ?
#define KAFF5 ?
#define KAFF6 ?

// prototypes
void traiteIT(void); 		// prototype car le vecteur est dclar avant la sp d'IT
void mux(void);
void decode (void);

// donnees decimales des 6 afficheurs 7 seg
unsigned char DAFF1;	
unsigned char DAFF2;	
unsigned char DAFF3;	
unsigned char DAFF4;	
unsigned char DAFF5;	
unsigned char DAFF6;	


rom unsigned char code7seg[]={?,?,?,?,?,?,?,?,?,?};

unsigned char heu, min, sec; // 

#pragma code it=0x08		// le vecteur d'IT prioritaire envoie  l'adresse 8
void saut_sur_spIT(void)	// une fonction, car en C tout est dans une fonction
{
_asm
	goto traiteIT			
_endasm
}
#pragma code				// le compilateur peut  nouveau grer les adresses


#pragma interrupt traiteIT	// traiteIT est un SP d'IT 
void traiteIT(void)			
{static unsigned int tictac=0;
	
	if( PIR1bits.CCP1IF)	// l'IT provient d'une comparaison
			{						
			if (++tictac>=  ?) { 		// il s'est passe une seconde 
									tictac=0;
									
										CALCULER heure minutes secondes
										
									decode();	// decode heu min sec
							 }
			mux();
			PIR1bits.CCP1IF=0;		//efface le drapeau d'IT
			}

}


// multiplexage de l'affichage
void mux(void)
{
	if (KAFF1)				// si l'afficheur 1 est allume
		{
			KAFF1=?;		// l'eteindre
			DATA=code7seg[DAFF?];	// placer le code d'allumage
			KAFF2=?;		// allumer le suivant
		}
	else if (KAFF2)	
		{
		?
		}
	else if (KAFF3)	
		{
		?
		}
	else if (KAFF4)	
		{
		?
		}
	else if (KAFF5)	
		{
		?
		}
	else if (KAFF6)	
		{
		?
		}

Nop();
}

// decodage 
void decode (void) // 
{

	DAFF1= chiffre des dizaines d heures
	DAFF2= chiffre des heures
	DAFF3= chiffre des dizaines de minutes
	DAFF4= chiffre des minutes
	DAFF5= chiffre des dizaines de secondesx
	DAFF6= chiffre des secondes
}


// indique qu'un caractre est dans RCREG de l'USART 
char data_recue(void)			// reception d'une interruption
{
	if (PIR1bits.RCIF)		/* char recu en reception*/
	{	
		PIR1bits.RCIF=0;	// efface drapeau
		return (1);			// indique qu'un nouveau caractre est dans RCREG
	}	
	else return (0);		// pas de nouveau caractre reu
}

// programme de test
void main (void)
{	
	ADCON0=0x0F;				// CAN on. CLOCK=FOSC/2. CANAL0 (RA)
	ADCON1=0b00001110;	// justification  droite, seul AN0 est activ, VREF+=VDD VREF-=VSS
	ADCON2=0b10000000;
	CMCON=0xCF;			// pour PORTA ET B numeriques
	TRISD=0b10000000;
	TRISC=0b11000000;
	TRISB=0b00000001;
			
	DATA=0x0;
	
	DAFF1=0;
	DAFF2=0;
	DAFF3=0;
	DAFF4=0;
	DAFF5=0;
	DAFF6=0;
	
	KAFF1=0;
	KAFF2=0;
	KAFF3=0;
	KAFF4=0;	
	KAFF5=0;
	KAFF6=1;	

// init USART	
	SPBRGH= 0x00;			// SPBRG est compose de SPBRGH et SPBRG
	SPBRG = 25; 	        /* configure la vitesse (BAUD) 9600 N 8 1 (QUARTZ 4MHz)*/
    TXSTA = 0b00100000; 	                  
	RCSTA = 0b10010000;		/* active l'USART*/
	BAUDCONbits.BRG16=0;	// SPBRGH = 0 pour 9600 
	TXSTAbits.BRGH=1;		// High Speed

	heu=10;
	min=30;
	sec=45;

// configure le TIMER1
	T1CONbits.RD16=0;		// TMR1 mode simple (pas de RW)
	T1CONbits.TMR1CS=?;		// compte les impulsions sur internal clock
	T1CONbits.T1CKPS1=?;	// prdiviseur =1/8 periode sortie = 8uS
	T1CONbits.T1CKPS0=?;	
	T1CONbits.T1SYNC=1;		// pas de synchronisation sur sleep/Reset	
	T1CONbits.TMR1ON=?;		// TMR1 Activ

// configure le mode comparaison sur le TIMER1 avec IT sur CCP1 toutes les 1250 priodes de 8us soit 10ms
	T3CONbits.T3CCP2=0;		// mode comparaison entre TMR1 et CCPR1
	CCP1CON=0x0B;			// Trigger special event sur comparaison (RAZ TIMER1 lors de l'galit)

	CCPR1H=?;			// galit aprs 1250 priodes 
	CCPR1L=?;

	PIE1bits.CCP1IE=1;		// active IT sur mode comparaison CCP1

	RCONbits.IPEN=1;		// Interruption prioritaires actives
	INTCONbits.GIE =1;	
	printf("Il est ..............);	
	printf (" S2 pour afficher l'heure \n\r");

	while(1)
				{
					if (!S2) printf(.......)	;	 
					while (!S2);	// attend relachement bouton
					Nop();
				}
}
