// CD 02/2010
// demo_it_rb0.c demo de mise en oeuvre des interruption
// ce programme incrmente une mmoire  chaque appuis sur S3

#include <p18f4620.h>

unsigned int cpt=0;	// compteur d'interruption

// sous programme d'interruption
#pragma interrupt it_sur_rb0		// choix du niveau d'interruption (donc du vecteur)
void it_sur_rb0(void)		
{
	if (INTCONbits.INT0IF)			// vrifie que l'IT est INT0, origine PB0=0 (bouton S3)
			{
				cpt++;					//utiliser un WATCH pour visualiser cpt
				INTCONbits.INT0IF=0;	//efface le drapeau d'IT
			}
}

#pragma code vecteur_d_IT=0x08	// vecteur d'IT
void une_fonction(void)
{
_asm goto it_sur_rb0 _endasm
}
#pragma code


void main (void)
{	ADCON1=0x0F;
	// configure IT sur PB0
	TRISBbits.TRISB0=1;		// PRB0 en entre
	INTCONbits.INT0IE=1;	// INT0 active 
	INTCONbits.GIE=1;		// Toutes les IT dmasques autorises

	while(1);		// attente d'un vnement, le programme ne fait plus rien
}
